<?php

namespace App\Commands;

use Illuminate\Console\Scheduling\Schedule;
use LaravelZero\Framework\Commands\Command;
use Illuminate\Support\Facades\Process;

class Redes_wifi extends Command
{
    /**
     * The signature of the command.
     *
     * @var string
     */
    protected $signature = 'wifi';

    /**
     * The description of the command.
     *
     * @var string
     */
    protected $description = 'Muestra las contraseñas guardadas de wifi';

    /**
     * Execute the console command.
     *
     * @return mixed
     */
    public function handle()
    {
        $profiles = $this->getProfiles();
        foreach ($profiles as $profile) {
            $this->line("[{$profile}] ".$this->getPassword($profile));
        }
    }

    public function listProfiles()
    {
        $result = Process::run('netsh wlan show profile');
        $salidaprofiles = $result->output();
        //$salidaprofiles = file_get_contents('profiles.txt');
        $parseprofiles = explode("-------------------", $salidaprofiles);
        $parseprofiles = end($parseprofiles);
        $parseprofiles = explode("\n", trim($parseprofiles, "\n"));
        $profiles = [];
        foreach ($parseprofiles as $profile) {
            $profiles[] = str_replace('    Perfil de todos los usuarios     : ', '', $profile);
        }
        return $profiles;
    }

    public function getPassword($profile)
    {
        $result = Process::run("netsh wlan show profile {$profile} key=clear");
        $salidapassword = $result->output();
        //$salidapassword = file_get_contents('prueba.txt');
        $parsepassword = explode('--------------------------', $salidapassword);
        $parsepassword = end($parsepassword);
        $parsepassword = explode("Configuraci", trim($parsepassword, "\n"));
        $parsepassword = current($parsepassword);
        $parsepassword = trim($parsepassword);
        $parsepassword = explode("\n", $parsepassword);
        $parsepassword = str_replace('    Contenido de la clave  : ', '', end($parsepassword));
        return $parsepassword;
    }

    /**
     * Define the command's schedule.
     *
     * @param  \Illuminate\Console\Scheduling\Schedule  $schedule
     * @return void
     */
    public function schedule(Schedule $schedule): void
    {
        // $schedule->command(static::class)->everyMinute();
    }
}
